%define _with_repolib 1

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define jmailver  1.4

Summary:        Glassfish - JavaMail Api 
Name:           glassfish-javamail
Version:        1.4.0
Release:        0jpp.ep1.8%{?dist}
Epoch:          0
License:        CDDL
Group:          Development/Java
URL:            http://glassfish.dev.java.net/

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildArch:      noarch
Source0:        %{name}-%{version}.tar.gz
#cvs -d :pserver:guest@cvs.dev.java.net:/cvs checkout glassfish/mail
Source1:	%{name}-%{version}-LICENCE.tar.gz
#cvs -d :pserver:guest@cvs.dev.java.net:/cvs checkout glassfish/bootstrap ... this tar is a tar of the legal folder under glassfish/bootstrap
Source2:	mail-1.4.pom
Source3:	%{name}-component-info.xml
Patch0:		%{name}-%{version}-ant-hack.patch

BuildRequires:  ant >= 0:1.6.5
BuildRequires:  jpackage-utils >= 0:1.7.2
BuildRequires:	glassfish-jaf
Requires:  glassfish-jaf

Provides:       javamail = 0:%{jmailver}
Provides:       javamail-monolithic = 0:%{jmailver}

%define repodir %{_javadir}/repository.jboss.com/sun-javamail/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%description
JavaMail Api from Glassfish

%package	javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm
Provides:       javamail-javadoc = 0:%{jmailver}

%description 	javadoc
%{summary}.

%if %{with_repolib}
%package	 repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	Development/Libraries/Java

%description	 repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%prep
%setup -n %{name} 

%patch -p1

tag=`echo %{version}-brew`
sed -i "s/@VERSION@/$tag/g" %{SOURCE3}
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE3}

#Unpack the LICENCE tarball
tar -xvzf %{SOURCE1}

%build
if [ -z "$JAVA_HOME" ]; then export JAVA_HOME=/usr/lib/jvm/java; fi
ant -Djavaee.jar=$(build-classpath glassfish-jaf) release

%install
rm -rf $RPM_BUILD_ROOT

# jars
%define jar_name mail
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -p -m 0644 build/release/%{jar_name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-monolithic-%{version}.jar
install -m 644 build/release/lib/dsn.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dsn-%{version}.jar
install -m 644 build/release/lib/imap.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/imap-%{version}.jar
install -m 644 build/release/lib/mailapi.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/mailapi-%{version}.jar
install -m 644 build/release/lib/pop3.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/pop3-%{version}.jar
install -m 644 build/release/lib/smtp.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/smtp-%{version}.jar

%add_to_maven_depmap javax.mail mail %{version} JPP %{name}-monolithic
%add_to_maven_depmap javax.mail dsn %{version} JPP/%{name} dsn
%add_to_maven_depmap javax.mail imap %{version} JPP/%{name} imap
%add_to_maven_depmap javax.mail mailapi %{version} JPP/%{name} mailapi
%add_to_maven_depmap javax.mail pop3 %{version} JPP/%{name} pop3
%add_to_maven_depmap javax.mail smtp %{version} JPP/%{name} smtp

pushd $RPM_BUILD_ROOT%{_javadir}
ln -sf %{name}-monolithic-%{version}.jar %{name}.jar
ln -sf %{name}-monolithic-%{version}.jar %{name}-monolithic.jar
#ln -sf %{name}-monolithic-%{version}.jar javamail.jar
popd

(cd $RPM_BUILD_ROOT%{_javadir}/%{name}
for jar in *-%{version}*.jar; do ln -sf ${jar} `echo ${jar} | sed "s|-%{version}||g"`;done)
touch $RPM_BUILD_ROOT%{_javadir}/javamail.jar

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 %{SOURCE2} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.pom

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/release/docs/javadocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p build/META-INF/LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -m 755 %{SOURCE3} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
	cp $RPM_BUILD_ROOT%{_javadir}/%{name}.jar $RPM_BUILD_ROOT%{repodirlib}/mail.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%post
%update_maven_depmap
/usr/sbin/update-alternatives --install %{_javadir}/javamail.jar javamail %{_javadir}/%{name}-monolithic-%{version}.jar 10100

%preun
if [ "$1" = "0" ]; then
    /usr/sbin/update-alternatives --remove javamail %{_javadir}/%{name}-monolithic-%{version}.jar
fi

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-monolithic-%{version}.jar
%{_javadir}/%{name}-monolithic.jar
%{_javadir}/%{name}.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/%{name}
%ghost %{_javadir}/javamail.jar

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif

%changelog
* Fri Nov 23 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.0-0jpp.ep1.8
- Revert to sun-javamail name due to buildmagic

* Fri Nov 23 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.4.0-0jpp.ep1.7
- Build with debug info

* Fri Nov 23 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.0-0jpp.ep1.6
- Parametrize component-info contents

* Thu Nov 22 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.4.0-0jpp.ep1.5
- Adding component-info.xml
- Change the repodir to glassfish/javamail

* Tue Nov 20 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.4.0-0jpp.ep1.4
- Adding in pom stuff

* Fri Nov 16 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.4.0-0jpp.ep1.3
- Adding glassfish-jaf to the classpath 

* Fri Nov 16 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.4.0-0jpp.ep1.2
- Rebuild

* Thu Nov 15 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.4.0-0jpp.ep1.1
- First release.
